/**
 * Copyright (c) 2022 Yansen Zhang
 * wxcomponent is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
**/

package errors

import "fmt"

// Error 通用错误
type Error struct {
	Code    int    `json:"errcode"`
	Message string `json:"errmsg"`
}

func (e *Error) Error() string {
	return fmt.Sprintf("[%d] - %s", e.Code, e.Message)
}

func New(msg string) error {
	return &Error{
		Code:    -100,
		Message: msg,
	}
}
